<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThreeDSecureType StructType
 * @subpackage Structs
 */
class ThreeDSecureType extends AbstractStructBase
{
    /**
     * The Enrolled
     * @var string
     */
    public $Enrolled;
    /**
     * The Paresstatus
     * @var string
     */
    public $Paresstatus;
    /**
     * The Eci
     * @var string
     */
    public $Eci;
    /**
     * The Xid
     * @var string
     */
    public $Xid;
    /**
     * The Cavv
     * @var string
     */
    public $Cavv;
    /**
     * The IssuerAuthCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IssuerAuthCode;
    /**
     * The AcsReferenceNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AcsReferenceNumber;
    /**
     * The ACSTransId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ACSTransId;
    /**
     * The DSTransId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DSTransId;
    /**
     * The MessageVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MessageVersion;
    /**
     * The ServerTransId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ServerTransId;
    /**
     * The TransStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransStatus;
    /**
     * The CavvAlgorithm
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CavvAlgorithm;
    /**
     * The ProtocolVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ProtocolVersion;
    /**
     * Constructor method for ThreeDSecureType
     * @uses ThreeDSecureType::setEnrolled()
     * @uses ThreeDSecureType::setParesstatus()
     * @uses ThreeDSecureType::setEci()
     * @uses ThreeDSecureType::setXid()
     * @uses ThreeDSecureType::setCavv()
     * @uses ThreeDSecureType::setIssuerAuthCode()
     * @uses ThreeDSecureType::setAcsReferenceNumber()
     * @uses ThreeDSecureType::setACSTransId()
     * @uses ThreeDSecureType::setDSTransId()
     * @uses ThreeDSecureType::setMessageVersion()
     * @uses ThreeDSecureType::setServerTransId()
     * @uses ThreeDSecureType::setTransStatus()
     * @uses ThreeDSecureType::setCavvAlgorithm()
     * @uses ThreeDSecureType::setProtocolVersion()
     * @param string $enrolled
     * @param string $paresstatus
     * @param string $eci
     * @param string $xid
     * @param string $cavv
     * @param string $issuerAuthCode
     * @param string $acsReferenceNumber
     * @param string $aCSTransId
     * @param string $dSTransId
     * @param string $messageVersion
     * @param string $serverTransId
     * @param string $transStatus
     * @param string $cavvAlgorithm
     * @param string $protocolVersion
     */
    public function __construct($enrolled = null, $paresstatus = null, $eci = null, $xid = null, $cavv = null, $issuerAuthCode = null, $acsReferenceNumber = null, $aCSTransId = null, $dSTransId = null, $messageVersion = null, $serverTransId = null, $transStatus = null, $cavvAlgorithm = null, $protocolVersion = null)
    {
        $this
            ->setEnrolled($enrolled)
            ->setParesstatus($paresstatus)
            ->setEci($eci)
            ->setXid($xid)
            ->setCavv($cavv)
            ->setIssuerAuthCode($issuerAuthCode)
            ->setAcsReferenceNumber($acsReferenceNumber)
            ->setACSTransId($aCSTransId)
            ->setDSTransId($dSTransId)
            ->setMessageVersion($messageVersion)
            ->setServerTransId($serverTransId)
            ->setTransStatus($transStatus)
            ->setCavvAlgorithm($cavvAlgorithm)
            ->setProtocolVersion($protocolVersion);
    }
    /**
     * Get Enrolled value
     * @return string|null
     */
    public function getEnrolled()
    {
        return $this->Enrolled;
    }
    /**
     * Set Enrolled value
     * @uses \EnumType\YNU::valueIsValid()
     * @uses \EnumType\YNU::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $enrolled
     * @return \StructType\ThreeDSecureType
     */
    public function setEnrolled($enrolled = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\YNU::valueIsValid($enrolled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\YNU', is_array($enrolled) ? implode(', ', $enrolled) : var_export($enrolled, true), implode(', ', \EnumType\YNU::getValidValues())), __LINE__);
        }
        $this->Enrolled = $enrolled;
        return $this;
    }
    /**
     * Get Paresstatus value
     * @return string|null
     */
    public function getParesstatus()
    {
        return $this->Paresstatus;
    }
    /**
     * Set Paresstatus value
     * @uses \EnumType\YNUA::valueIsValid()
     * @uses \EnumType\YNUA::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $paresstatus
     * @return \StructType\ThreeDSecureType
     */
    public function setParesstatus($paresstatus = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\YNUA::valueIsValid($paresstatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\YNUA', is_array($paresstatus) ? implode(', ', $paresstatus) : var_export($paresstatus, true), implode(', ', \EnumType\YNUA::getValidValues())), __LINE__);
        }
        $this->Paresstatus = $paresstatus;
        return $this;
    }
    /**
     * Get Eci value
     * @return string|null
     */
    public function getEci()
    {
        return $this->Eci;
    }
    /**
     * Set Eci value
     * @param string $eci
     * @return \StructType\ThreeDSecureType
     */
    public function setEci($eci = null)
    {
        // validation for constraint: string
        if (!is_null($eci) && !is_string($eci)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eci, true), gettype($eci)), __LINE__);
        }
        $this->Eci = $eci;
        return $this;
    }
    /**
     * Get Xid value
     * @return string|null
     */
    public function getXid()
    {
        return $this->Xid;
    }
    /**
     * Set Xid value
     * @param string $xid
     * @return \StructType\ThreeDSecureType
     */
    public function setXid($xid = null)
    {
        // validation for constraint: string
        if (!is_null($xid) && !is_string($xid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xid, true), gettype($xid)), __LINE__);
        }
        $this->Xid = $xid;
        return $this;
    }
    /**
     * Get Cavv value
     * @return string|null
     */
    public function getCavv()
    {
        return $this->Cavv;
    }
    /**
     * Set Cavv value
     * @param string $cavv
     * @return \StructType\ThreeDSecureType
     */
    public function setCavv($cavv = null)
    {
        // validation for constraint: string
        if (!is_null($cavv) && !is_string($cavv)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cavv, true), gettype($cavv)), __LINE__);
        }
        $this->Cavv = $cavv;
        return $this;
    }
    /**
     * Get IssuerAuthCode value
     * @return string|null
     */
    public function getIssuerAuthCode()
    {
        return $this->IssuerAuthCode;
    }
    /**
     * Set IssuerAuthCode value
     * @param string $issuerAuthCode
     * @return \StructType\ThreeDSecureType
     */
    public function setIssuerAuthCode($issuerAuthCode = null)
    {
        // validation for constraint: string
        if (!is_null($issuerAuthCode) && !is_string($issuerAuthCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($issuerAuthCode, true), gettype($issuerAuthCode)), __LINE__);
        }
        $this->IssuerAuthCode = $issuerAuthCode;
        return $this;
    }
    /**
     * Get AcsReferenceNumber value
     * @return string|null
     */
    public function getAcsReferenceNumber()
    {
        return $this->AcsReferenceNumber;
    }
    /**
     * Set AcsReferenceNumber value
     * @param string $acsReferenceNumber
     * @return \StructType\ThreeDSecureType
     */
    public function setAcsReferenceNumber($acsReferenceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($acsReferenceNumber) && !is_string($acsReferenceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($acsReferenceNumber, true), gettype($acsReferenceNumber)), __LINE__);
        }
        $this->AcsReferenceNumber = $acsReferenceNumber;
        return $this;
    }
    /**
     * Get ACSTransId value
     * @return string|null
     */
    public function getACSTransId()
    {
        return $this->ACSTransId;
    }
    /**
     * Set ACSTransId value
     * @param string $aCSTransId
     * @return \StructType\ThreeDSecureType
     */
    public function setACSTransId($aCSTransId = null)
    {
        // validation for constraint: string
        if (!is_null($aCSTransId) && !is_string($aCSTransId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aCSTransId, true), gettype($aCSTransId)), __LINE__);
        }
        $this->ACSTransId = $aCSTransId;
        return $this;
    }
    /**
     * Get DSTransId value
     * @return string|null
     */
    public function getDSTransId()
    {
        return $this->DSTransId;
    }
    /**
     * Set DSTransId value
     * @param string $dSTransId
     * @return \StructType\ThreeDSecureType
     */
    public function setDSTransId($dSTransId = null)
    {
        // validation for constraint: string
        if (!is_null($dSTransId) && !is_string($dSTransId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dSTransId, true), gettype($dSTransId)), __LINE__);
        }
        $this->DSTransId = $dSTransId;
        return $this;
    }
    /**
     * Get MessageVersion value
     * @return string|null
     */
    public function getMessageVersion()
    {
        return $this->MessageVersion;
    }
    /**
     * Set MessageVersion value
     * @param string $messageVersion
     * @return \StructType\ThreeDSecureType
     */
    public function setMessageVersion($messageVersion = null)
    {
        // validation for constraint: string
        if (!is_null($messageVersion) && !is_string($messageVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($messageVersion, true), gettype($messageVersion)), __LINE__);
        }
        $this->MessageVersion = $messageVersion;
        return $this;
    }
    /**
     * Get ServerTransId value
     * @return string|null
     */
    public function getServerTransId()
    {
        return $this->ServerTransId;
    }
    /**
     * Set ServerTransId value
     * @param string $serverTransId
     * @return \StructType\ThreeDSecureType
     */
    public function setServerTransId($serverTransId = null)
    {
        // validation for constraint: string
        if (!is_null($serverTransId) && !is_string($serverTransId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serverTransId, true), gettype($serverTransId)), __LINE__);
        }
        $this->ServerTransId = $serverTransId;
        return $this;
    }
    /**
     * Get TransStatus value
     * @return string|null
     */
    public function getTransStatus()
    {
        return $this->TransStatus;
    }
    /**
     * Set TransStatus value
     * @param string $transStatus
     * @return \StructType\ThreeDSecureType
     */
    public function setTransStatus($transStatus = null)
    {
        // validation for constraint: string
        if (!is_null($transStatus) && !is_string($transStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transStatus, true), gettype($transStatus)), __LINE__);
        }
        $this->TransStatus = $transStatus;
        return $this;
    }
    /**
     * Get CavvAlgorithm value
     * @return string|null
     */
    public function getCavvAlgorithm()
    {
        return $this->CavvAlgorithm;
    }
    /**
     * Set CavvAlgorithm value
     * @param string $cavvAlgorithm
     * @return \StructType\ThreeDSecureType
     */
    public function setCavvAlgorithm($cavvAlgorithm = null)
    {
        // validation for constraint: string
        if (!is_null($cavvAlgorithm) && !is_string($cavvAlgorithm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cavvAlgorithm, true), gettype($cavvAlgorithm)), __LINE__);
        }
        $this->CavvAlgorithm = $cavvAlgorithm;
        return $this;
    }
    /**
     * Get ProtocolVersion value
     * @return string|null
     */
    public function getProtocolVersion()
    {
        return $this->ProtocolVersion;
    }
    /**
     * Set ProtocolVersion value
     * @param string $protocolVersion
     * @return \StructType\ThreeDSecureType
     */
    public function setProtocolVersion($protocolVersion = null)
    {
        // validation for constraint: string
        if (!is_null($protocolVersion) && !is_string($protocolVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($protocolVersion, true), gettype($protocolVersion)), __LINE__);
        }
        $this->ProtocolVersion = $protocolVersion;
        return $this;
    }
}
